/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.Admin
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.4.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * Retuned when searching for a project. Contains basic informations and quotas.
 * @export
 * @interface ProjectObject
 */
export interface ProjectObject {
    /**
     * Projectname (full project name)
     * @type {string}
     * @memberof ProjectObject
     */
    name?: string | null;
    /**
     * Shortname (display name)
     * @type {string}
     * @memberof ProjectObject
     */
    shortName?: string | null;
    /**
     * GUID (project id)
     * @type {string}
     * @memberof ProjectObject
     */
    guid?: string;
    /**
     * List of the project quotas (ProjectQuotaObject)
     * @type {Array<ProjectQuotaObject>}
     * @memberof ProjectObject
     */
    quotas?: Array<ProjectQuotaObject> | null;
}
/**
 * Returned when searching for a project, as part of the ProjectQbect. Contains quota informations.
 * @export
 * @interface ProjectQuotaObject
 */
export interface ProjectQuotaObject {
    /**
     * Id of the quota.
     * @type {string}
     * @memberof ProjectQuotaObject
     */
    quotaId?: string;
    /**
     * Which resourceType the quota is referencing.
     * @type {string}
     * @memberof ProjectQuotaObject
     */
    resourceType?: string | null;
    /**
     * The quota value.
     * @type {number}
     * @memberof ProjectQuotaObject
     */
    quota?: number;
    /**
     * The MaxQuota value.
     * @type {number}
     * @memberof ProjectQuotaObject
     */
    maxQuota?: number;
    /**
     * How much space is used by the resource (rounded up and in gb).
     * @type {number}
     * @memberof ProjectQuotaObject
     */
    used?: number | null;
    /**
     * How much space is availabe to be taken by resource (in gb).
     * @type {number}
     * @memberof ProjectQuotaObject
     */
    allocated?: number | null;
}
/**
 * Data send to update the project quota.
 * @export
 * @interface UpdateQuotaParameterObject
 */
export interface UpdateQuotaParameterObject {
    /**
     * The id (Guid) of the quota.
     * @type {string}
     * @memberof UpdateQuotaParameterObject
     */
    quotaId?: string;
    /**
     * The new quota value.
     * @type {number}
     * @memberof UpdateQuotaParameterObject
     */
    quota?: number;
}

/**
 * AdminApi - axios parameter creator
 * @export
 */
export const AdminApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Find the project related to the projectString(GUID or slug)
         * @param {string} projectString Either the id (GUID) of the project or the slug.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        adminGetProject: async (projectString: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectString' is not null or undefined
            assertParamExists('adminGetProject', 'projectString', projectString)
            const localVarPath = `/Admin/{projectString}`
                .replace(`{${"projectString"}}`, encodeURIComponent(String(projectString)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update the project quota
         * @param {UpdateQuotaParameterObject} updateQuotaParameterObject JSON object for updating quota.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        adminUpdateQuota: async (updateQuotaParameterObject: UpdateQuotaParameterObject, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'updateQuotaParameterObject' is not null or undefined
            assertParamExists('adminUpdateQuota', 'updateQuotaParameterObject', updateQuotaParameterObject)
            const localVarPath = `/Admin`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateQuotaParameterObject, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AdminApi - functional programming interface
 * @export
 */
export const AdminApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = AdminApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Find the project related to the projectString(GUID or slug)
         * @param {string} projectString Either the id (GUID) of the project or the slug.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async adminGetProject(projectString: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.adminGetProject(projectString, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update the project quota
         * @param {UpdateQuotaParameterObject} updateQuotaParameterObject JSON object for updating quota.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async adminUpdateQuota(updateQuotaParameterObject: UpdateQuotaParameterObject, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.adminUpdateQuota(updateQuotaParameterObject, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * AdminApi - factory interface
 * @export
 */
export const AdminApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = AdminApiFp(configuration)
    return {
        /**
         * 
         * @summary Find the project related to the projectString(GUID or slug)
         * @param {string} projectString Either the id (GUID) of the project or the slug.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        adminGetProject(projectString: string, options?: any): AxiosPromise<ProjectObject> {
            return localVarFp.adminGetProject(projectString, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update the project quota
         * @param {UpdateQuotaParameterObject} updateQuotaParameterObject JSON object for updating quota.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        adminUpdateQuota(updateQuotaParameterObject: UpdateQuotaParameterObject, options?: any): AxiosPromise<any> {
            return localVarFp.adminUpdateQuota(updateQuotaParameterObject, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * AdminApi - object-oriented interface
 * @export
 * @class AdminApi
 * @extends {BaseAPI}
 */
export class AdminApi extends BaseAPI {
    /**
     * 
     * @summary Find the project related to the projectString(GUID or slug)
     * @param {string} projectString Either the id (GUID) of the project or the slug.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public adminGetProject(projectString: string, options?: any) {
        return AdminApiFp(this.configuration).adminGetProject(projectString, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update the project quota
     * @param {UpdateQuotaParameterObject} updateQuotaParameterObject JSON object for updating quota.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AdminApi
     */
    public adminUpdateQuota(updateQuotaParameterObject: UpdateQuotaParameterObject, options?: any) {
        return AdminApiFp(this.configuration).adminUpdateQuota(updateQuotaParameterObject, options).then((request) => request(this.axios, this.basePath));
    }
}


