/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.Metadata
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 3.0.2
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * Parameter object containing the application profile informations.             
 * @export
 * @interface ApplicationProfile
 */
export interface ApplicationProfile {
    /**
     * Name of the application profile             
     * @type {string}
     * @memberof ApplicationProfile
     */
    name?: string | null;
    /**
     * Base URL of the application profile             
     * @type {string}
     * @memberof ApplicationProfile
     */
    base_url?: string | null;
    /**
     * Definition of the application profile             
     * @type {string}
     * @memberof ApplicationProfile
     */
    definition?: string | null;
    /**
     * Mime type of the application profile             
     * @type {string}
     * @memberof ApplicationProfile
     */
    mimeType?: string | null;
}
/**
 * Bilingual labels
 * @export
 * @interface BilingualLabels
 */
export interface BilingualLabels {
    /**
     * English labels
     * @type {Array<Label>}
     * @memberof BilingualLabels
     */
    en?: Array<Label> | null;
    /**
     * German labels
     * @type {Array<Label>}
     * @memberof BilingualLabels
     */
    de?: Array<Label> | null;
}
/**
 * Label of a vocabulary entry
 * @export
 * @interface Label
 */
export interface Label {
    /**
     * Name of the application profile             
     * @type {string}
     * @memberof Label
     */
    name?: string | null;
    /**
     * Name of the application profile             
     * @type {string}
     * @memberof Label
     */
    value?: string | null;
}

/**
 * MetadataApi - axios parameter creator
 * @export
 */
export const MetadataApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary This method returns instances.
         * @param {string} className class name
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetClassInstances: async (className: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'className' is not null or undefined
            assertParamExists('metadataGetClassInstances', 'className', className)
            const localVarPath = `/Metadata/instances/{className}`
                .replace(`{${"className"}}`, encodeURIComponent(String(className)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary This method returns the application profile for the given profileUrl.
         * @param {string} profile Url of the application profile
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetProfile: async (profile: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'profile' is not null or undefined
            assertParamExists('metadataGetProfile', 'profile', profile)
            const localVarPath = `/Metadata/profiles/{profile}`
                .replace(`{${"profile"}}`, encodeURIComponent(String(profile)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary This method returns all application profiles.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetProfiles: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Metadata/profiles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary This method returns a list of all vocabularies.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetVocabularies: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Metadata/vocabularies`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary This method returns a specific vocabulary.
         * @param {string} path Url of the vocabulary
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetVocabulary: async (path: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'path' is not null or undefined
            assertParamExists('metadataGetVocabulary', 'path', path)
            const localVarPath = `/Metadata/vocabularies/{path}`
                .replace(`{${"path"}}`, encodeURIComponent(String(path)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a request for storing a given application profile.
         * @param {ApplicationProfile} applicationProfile Object describing the application profile
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataSaveApplicationProfile: async (applicationProfile: ApplicationProfile, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'applicationProfile' is not null or undefined
            assertParamExists('metadataSaveApplicationProfile', 'applicationProfile', applicationProfile)
            const localVarPath = `/Metadata/profiles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(applicationProfile, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * MetadataApi - functional programming interface
 * @export
 */
export const MetadataApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = MetadataApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary This method returns instances.
         * @param {string} className class name
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataGetClassInstances(className: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BilingualLabels>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataGetClassInstances(className, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary This method returns the application profile for the given profileUrl.
         * @param {string} profile Url of the application profile
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataGetProfile(profile: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataGetProfile(profile, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary This method returns all application profiles.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataGetProfiles(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<string>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataGetProfiles(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary This method returns a list of all vocabularies.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataGetVocabularies(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<string>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataGetVocabularies(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary This method returns a specific vocabulary.
         * @param {string} path Url of the vocabulary
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataGetVocabulary(path: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BilingualLabels>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataGetVocabulary(path, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a request for storing a given application profile.
         * @param {ApplicationProfile} applicationProfile Object describing the application profile
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async metadataSaveApplicationProfile(applicationProfile: ApplicationProfile, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.metadataSaveApplicationProfile(applicationProfile, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * MetadataApi - factory interface
 * @export
 */
export const MetadataApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = MetadataApiFp(configuration)
    return {
        /**
         * 
         * @summary This method returns instances.
         * @param {string} className class name
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetClassInstances(className: string, options?: any): AxiosPromise<BilingualLabels> {
            return localVarFp.metadataGetClassInstances(className, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary This method returns the application profile for the given profileUrl.
         * @param {string} profile Url of the application profile
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetProfile(profile: string, options?: any): AxiosPromise<any> {
            return localVarFp.metadataGetProfile(profile, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary This method returns all application profiles.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetProfiles(options?: any): AxiosPromise<Array<string>> {
            return localVarFp.metadataGetProfiles(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary This method returns a list of all vocabularies.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetVocabularies(options?: any): AxiosPromise<Array<string>> {
            return localVarFp.metadataGetVocabularies(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary This method returns a specific vocabulary.
         * @param {string} path Url of the vocabulary
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataGetVocabulary(path: string, options?: any): AxiosPromise<BilingualLabels> {
            return localVarFp.metadataGetVocabulary(path, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a request for storing a given application profile.
         * @param {ApplicationProfile} applicationProfile Object describing the application profile
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        metadataSaveApplicationProfile(applicationProfile: ApplicationProfile, options?: any): AxiosPromise<any> {
            return localVarFp.metadataSaveApplicationProfile(applicationProfile, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * MetadataApi - object-oriented interface
 * @export
 * @class MetadataApi
 * @extends {BaseAPI}
 */
export class MetadataApi extends BaseAPI {
    /**
     * 
     * @summary This method returns instances.
     * @param {string} className class name
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataGetClassInstances(className: string, options?: any) {
        return MetadataApiFp(this.configuration).metadataGetClassInstances(className, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary This method returns the application profile for the given profileUrl.
     * @param {string} profile Url of the application profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataGetProfile(profile: string, options?: any) {
        return MetadataApiFp(this.configuration).metadataGetProfile(profile, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary This method returns all application profiles.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataGetProfiles(options?: any) {
        return MetadataApiFp(this.configuration).metadataGetProfiles(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary This method returns a list of all vocabularies.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataGetVocabularies(options?: any) {
        return MetadataApiFp(this.configuration).metadataGetVocabularies(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary This method returns a specific vocabulary.
     * @param {string} path Url of the vocabulary
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataGetVocabulary(path: string, options?: any) {
        return MetadataApiFp(this.configuration).metadataGetVocabulary(path, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a request for storing a given application profile.
     * @param {ApplicationProfile} applicationProfile Object describing the application profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MetadataApi
     */
    public metadataSaveApplicationProfile(applicationProfile: ApplicationProfile, options?: any) {
        return MetadataApiFp(this.configuration).metadataSaveApplicationProfile(applicationProfile, options).then((request) => request(this.axios, this.basePath));
    }
}


