/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.Notices
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.2.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * This class represents a maintenance with its significant properties, which is returned from the api.
 * @export
 * @interface MaintenanceReturnObject
 */
export interface MaintenanceReturnObject {
    /**
     * Maintenance title.
     * @type {string}
     * @memberof MaintenanceReturnObject
     */
    displayName?: string | null;
    /**
     * Maintenance url.
     * @type {string}
     * @memberof MaintenanceReturnObject
     */
    url?: string | null;
    /**
     * Maintenance type.
     * @type {string}
     * @memberof MaintenanceReturnObject
     */
    type?: string | null;
    /**
     * Maintenance description.
     * @type {string}
     * @memberof MaintenanceReturnObject
     */
    body?: string | null;
    /**
     * Maintenance start.
     * @type {string}
     * @memberof MaintenanceReturnObject
     */
    startsDate?: string | null;
    /**
     * Maintenance end.
     * @type {string}
     * @memberof MaintenanceReturnObject
     */
    endsDate?: string | null;
}

/**
 * NoticeApi - axios parameter creator
 * @export
 */
export const NoticeApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Returns defined properties of the first entry of the rss feed
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        noticeGetMaintenance: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Notice/getMaintenance`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Returns a notice
         * @param {string} documentSlug Slug defining a configured notice
         * @param {string} [language] Language (e.g. \&quot;en\&quot; or \&quot;de\&quot;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        noticeGetNotice: async (documentSlug: string, language?: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'documentSlug' is not null or undefined
            assertParamExists('noticeGetNotice', 'documentSlug', documentSlug)
            const localVarPath = `/Notice/{documentSlug}`
                .replace(`{${"documentSlug"}}`, encodeURIComponent(String(documentSlug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (language !== undefined) {
                localVarQueryParameter['language'] = language;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * NoticeApi - functional programming interface
 * @export
 */
export const NoticeApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = NoticeApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Returns defined properties of the first entry of the rss feed
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async noticeGetMaintenance(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MaintenanceReturnObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.noticeGetMaintenance(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Returns a notice
         * @param {string} documentSlug Slug defining a configured notice
         * @param {string} [language] Language (e.g. \&quot;en\&quot; or \&quot;de\&quot;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async noticeGetNotice(documentSlug: string, language?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.noticeGetNotice(documentSlug, language, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * NoticeApi - factory interface
 * @export
 */
export const NoticeApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = NoticeApiFp(configuration)
    return {
        /**
         * 
         * @summary Returns defined properties of the first entry of the rss feed
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        noticeGetMaintenance(options?: any): AxiosPromise<MaintenanceReturnObject> {
            return localVarFp.noticeGetMaintenance(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Returns a notice
         * @param {string} documentSlug Slug defining a configured notice
         * @param {string} [language] Language (e.g. \&quot;en\&quot; or \&quot;de\&quot;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        noticeGetNotice(documentSlug: string, language?: string, options?: any): AxiosPromise<any> {
            return localVarFp.noticeGetNotice(documentSlug, language, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * NoticeApi - object-oriented interface
 * @export
 * @class NoticeApi
 * @extends {BaseAPI}
 */
export class NoticeApi extends BaseAPI {
    /**
     * 
     * @summary Returns defined properties of the first entry of the rss feed
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NoticeApi
     */
    public noticeGetMaintenance(options?: any) {
        return NoticeApiFp(this.configuration).noticeGetMaintenance(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Returns a notice
     * @param {string} documentSlug Slug defining a configured notice
     * @param {string} [language] Language (e.g. \&quot;en\&quot; or \&quot;de\&quot;)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof NoticeApi
     */
    public noticeGetNotice(documentSlug: string, language?: string, options?: any) {
        return NoticeApiFp(this.configuration).noticeGetNotice(documentSlug, language, options).then((request) => request(this.axios, this.basePath));
    }
}


