/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.Organization
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';


/**
 * OrganizationApi - axios parameter creator
 * @export
 */
export const OrganizationApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Returns a specific organization.
         * @param {string} url Url of the organization.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationGetOrganization: async (url: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'url' is not null or undefined
            assertParamExists('organizationGetOrganization', 'url', url)
            const localVarPath = `/Organization/{url}`
                .replace(`{${"url"}}`, encodeURIComponent(String(url)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Returns all labels and urls from the ror graph.
         * @param {string} [filter] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationGetROR: async (filter?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Organization/-/ror`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (filter !== undefined) {
                localVarQueryParameter['filter'] = filter;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Returns all organizations that match the provided criterea.
         * @param {number} [member] Filtering organizations that the user is member of.
         * @param {string} [filter] Searchterm to filter the results by.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationIndex: async (member?: number, filter?: string, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Organization`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (member !== undefined) {
                localVarQueryParameter['member'] = member;
            }

            if (filter !== undefined) {
                localVarQueryParameter['filter'] = filter;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Returns true if the current user is a member of the given organization.
         * @param {string} url Url of the organization.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationIsMember: async (url: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'url' is not null or undefined
            assertParamExists('organizationIsMember', 'url', url)
            const localVarPath = `/Organization/-/isMember/{url}`
                .replace(`{${"url"}}`, encodeURIComponent(String(url)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Returns a list of organizations in which the current user is a member.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationIsMember2: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Organization/-/isMember`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * OrganizationApi - functional programming interface
 * @export
 */
export const OrganizationApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = OrganizationApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Returns a specific organization.
         * @param {string} url Url of the organization.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organizationGetOrganization(url: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.organizationGetOrganization(url, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Returns all labels and urls from the ror graph.
         * @param {string} [filter] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organizationGetROR(filter?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.organizationGetROR(filter, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Returns all organizations that match the provided criterea.
         * @param {number} [member] Filtering organizations that the user is member of.
         * @param {string} [filter] Searchterm to filter the results by.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organizationIndex(member?: number, filter?: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.organizationIndex(member, filter, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Returns true if the current user is a member of the given organization.
         * @param {string} url Url of the organization.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organizationIsMember(url: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.organizationIsMember(url, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Returns a list of organizations in which the current user is a member.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organizationIsMember2(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.organizationIsMember2(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * OrganizationApi - factory interface
 * @export
 */
export const OrganizationApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = OrganizationApiFp(configuration)
    return {
        /**
         * 
         * @summary Returns a specific organization.
         * @param {string} url Url of the organization.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationGetOrganization(url: string, options?: any): AxiosPromise<any> {
            return localVarFp.organizationGetOrganization(url, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Returns all labels and urls from the ror graph.
         * @param {string} [filter] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationGetROR(filter?: string, options?: any): AxiosPromise<any> {
            return localVarFp.organizationGetROR(filter, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Returns all organizations that match the provided criterea.
         * @param {number} [member] Filtering organizations that the user is member of.
         * @param {string} [filter] Searchterm to filter the results by.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationIndex(member?: number, filter?: string, options?: any): AxiosPromise<any> {
            return localVarFp.organizationIndex(member, filter, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Returns true if the current user is a member of the given organization.
         * @param {string} url Url of the organization.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationIsMember(url: string, options?: any): AxiosPromise<any> {
            return localVarFp.organizationIsMember(url, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Returns a list of organizations in which the current user is a member.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationIsMember2(options?: any): AxiosPromise<any> {
            return localVarFp.organizationIsMember2(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * OrganizationApi - object-oriented interface
 * @export
 * @class OrganizationApi
 * @extends {BaseAPI}
 */
export class OrganizationApi extends BaseAPI {
    /**
     * 
     * @summary Returns a specific organization.
     * @param {string} url Url of the organization.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganizationApi
     */
    public organizationGetOrganization(url: string, options?: any) {
        return OrganizationApiFp(this.configuration).organizationGetOrganization(url, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Returns all labels and urls from the ror graph.
     * @param {string} [filter] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganizationApi
     */
    public organizationGetROR(filter?: string, options?: any) {
        return OrganizationApiFp(this.configuration).organizationGetROR(filter, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Returns all organizations that match the provided criterea.
     * @param {number} [member] Filtering organizations that the user is member of.
     * @param {string} [filter] Searchterm to filter the results by.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganizationApi
     */
    public organizationIndex(member?: number, filter?: string, options?: any) {
        return OrganizationApiFp(this.configuration).organizationIndex(member, filter, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Returns true if the current user is a member of the given organization.
     * @param {string} url Url of the organization.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganizationApi
     */
    public organizationIsMember(url: string, options?: any) {
        return OrganizationApiFp(this.configuration).organizationIsMember(url, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Returns a list of organizations in which the current user is a member.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrganizationApi
     */
    public organizationIsMember2(options?: any) {
        return OrganizationApiFp(this.configuration).organizationIsMember2(options).then((request) => request(this.axios, this.basePath));
    }
}


