/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.Quota
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.5.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * Contains information about the quota of a resource.
 * @export
 * @interface ProjectQuotaReturnObject
 */
export interface ProjectQuotaReturnObject {
    /**
     * Id of the resoure.
     * @type {string}
     * @memberof ProjectQuotaReturnObject
     */
    id?: string;
    /**
     * Display name of the resource.
     * @type {string}
     * @memberof ProjectQuotaReturnObject
     */
    name?: string | null;
    /**
     * How much space is used by the resource (rounded up and in gb).
     * @type {number}
     * @memberof ProjectQuotaReturnObject
     */
    used?: number;
    /**
     * How much space is availabe to be taken by resource (in gb).
     * @type {number}
     * @memberof ProjectQuotaReturnObject
     */
    allocated?: number;
}
/**
 * Parameter object containing the update informations.             
 * @export
 * @interface UpdateResourceObject
 */
export interface UpdateResourceObject {
    /**
     * Id of the resource.             
     * @type {string}
     * @memberof UpdateResourceObject
     */
    id?: string;
    /**
     * New Quota value.
     * @type {number}
     * @memberof UpdateResourceObject
     */
    allocated?: number;
}

/**
 * QuotaApi - axios parameter creator
 * @export
 */
export const QuotaApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Retrieves the quota for the resource.
         * @param {string} resourceId Id of the resource.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        quotaGetResourceQuota: async (resourceId: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('quotaGetResourceQuota', 'resourceId', resourceId)
            const localVarPath = `/Quota/{resourceId}`
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the quota for the selected project and resource type.
         * @param {string} projectId Id of the project.
         * @param {string} resourceTypeId Id of the resource type.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        quotaGetResourceQuotas: async (projectId: string, resourceTypeId: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('quotaGetResourceQuotas', 'projectId', projectId)
            // verify required parameter 'resourceTypeId' is not null or undefined
            assertParamExists('quotaGetResourceQuotas', 'resourceTypeId', resourceTypeId)
            const localVarPath = `/Quota/{projectId}/{resourceTypeId}/all`
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)))
                .replace(`{${"resourceTypeId"}}`, encodeURIComponent(String(resourceTypeId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates the quota for a resource.
         * @param {string} resourceId 
         * @param {UpdateResourceObject} updateResourceObject Contains the resource id and the new quota.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        quotaUpdateResourceQuota: async (resourceId: string, updateResourceObject: UpdateResourceObject, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'resourceId' is not null or undefined
            assertParamExists('quotaUpdateResourceQuota', 'resourceId', resourceId)
            // verify required parameter 'updateResourceObject' is not null or undefined
            assertParamExists('quotaUpdateResourceQuota', 'updateResourceObject', updateResourceObject)
            const localVarPath = `/Quota/{resourceId}`
                .replace(`{${"resourceId"}}`, encodeURIComponent(String(resourceId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateResourceObject, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * QuotaApi - functional programming interface
 * @export
 */
export const QuotaApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = QuotaApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Retrieves the quota for the resource.
         * @param {string} resourceId Id of the resource.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async quotaGetResourceQuota(resourceId: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProjectQuotaReturnObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.quotaGetResourceQuota(resourceId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Retrieves the quota for the selected project and resource type.
         * @param {string} projectId Id of the project.
         * @param {string} resourceTypeId Id of the resource type.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async quotaGetResourceQuotas(projectId: string, resourceTypeId: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<ProjectQuotaReturnObject>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.quotaGetResourceQuotas(projectId, resourceTypeId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Updates the quota for a resource.
         * @param {string} resourceId 
         * @param {UpdateResourceObject} updateResourceObject Contains the resource id and the new quota.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async quotaUpdateResourceQuota(resourceId: string, updateResourceObject: UpdateResourceObject, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.quotaUpdateResourceQuota(resourceId, updateResourceObject, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * QuotaApi - factory interface
 * @export
 */
export const QuotaApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = QuotaApiFp(configuration)
    return {
        /**
         * 
         * @summary Retrieves the quota for the resource.
         * @param {string} resourceId Id of the resource.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        quotaGetResourceQuota(resourceId: string, options?: any): AxiosPromise<ProjectQuotaReturnObject> {
            return localVarFp.quotaGetResourceQuota(resourceId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the quota for the selected project and resource type.
         * @param {string} projectId Id of the project.
         * @param {string} resourceTypeId Id of the resource type.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        quotaGetResourceQuotas(projectId: string, resourceTypeId: string, options?: any): AxiosPromise<Array<ProjectQuotaReturnObject>> {
            return localVarFp.quotaGetResourceQuotas(projectId, resourceTypeId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates the quota for a resource.
         * @param {string} resourceId 
         * @param {UpdateResourceObject} updateResourceObject Contains the resource id and the new quota.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        quotaUpdateResourceQuota(resourceId: string, updateResourceObject: UpdateResourceObject, options?: any): AxiosPromise<any> {
            return localVarFp.quotaUpdateResourceQuota(resourceId, updateResourceObject, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * QuotaApi - object-oriented interface
 * @export
 * @class QuotaApi
 * @extends {BaseAPI}
 */
export class QuotaApi extends BaseAPI {
    /**
     * 
     * @summary Retrieves the quota for the resource.
     * @param {string} resourceId Id of the resource.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QuotaApi
     */
    public quotaGetResourceQuota(resourceId: string, options?: any) {
        return QuotaApiFp(this.configuration).quotaGetResourceQuota(resourceId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the quota for the selected project and resource type.
     * @param {string} projectId Id of the project.
     * @param {string} resourceTypeId Id of the resource type.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QuotaApi
     */
    public quotaGetResourceQuotas(projectId: string, resourceTypeId: string, options?: any) {
        return QuotaApiFp(this.configuration).quotaGetResourceQuotas(projectId, resourceTypeId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates the quota for a resource.
     * @param {string} resourceId 
     * @param {UpdateResourceObject} updateResourceObject Contains the resource id and the new quota.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof QuotaApi
     */
    public quotaUpdateResourceQuota(resourceId: string, updateResourceObject: UpdateResourceObject, options?: any) {
        return QuotaApiFp(this.configuration).quotaUpdateResourceQuota(resourceId, updateResourceObject, options).then((request) => request(this.axios, this.basePath));
    }
}


