/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.Search
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.2.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface SearchResult
 */
export interface SearchResult {
    /**
     * 
     * @type {string}
     * @memberof SearchResult
     */
    graphName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof SearchResult
     */
    project?: string | null;
    /**
     * 
     * @type {any}
     * @memberof SearchResult
     */
    source?: any | null;
}

/**
 * SemanticSearchApi - axios parameter creator
 * @export
 */
export const SemanticSearchApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Search with SemanticSearch;
         * @param {string} [query] Elasticsearch query
         * @param {boolean} [user] Specify user or only public metadata records could be found
         * @param {boolean} [adv] Set true for advanced Elasticsearch search syntax
         * @param {Array<string>} [languages] Set the used languages
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        semanticSearchSearch: async (query?: string, user?: boolean, adv?: boolean, languages?: Array<string>, options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/SemanticSearch`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (query !== undefined) {
                localVarQueryParameter['query'] = query;
            }

            if (user !== undefined) {
                localVarQueryParameter['user'] = user;
            }

            if (adv !== undefined) {
                localVarQueryParameter['adv'] = adv;
            }

            if (languages) {
                localVarQueryParameter['languages'] = languages;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SemanticSearchApi - functional programming interface
 * @export
 */
export const SemanticSearchApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SemanticSearchApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Search with SemanticSearch;
         * @param {string} [query] Elasticsearch query
         * @param {boolean} [user] Specify user or only public metadata records could be found
         * @param {boolean} [adv] Set true for advanced Elasticsearch search syntax
         * @param {Array<string>} [languages] Set the used languages
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async semanticSearchSearch(query?: string, user?: boolean, adv?: boolean, languages?: Array<string>, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<SearchResult>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.semanticSearchSearch(query, user, adv, languages, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SemanticSearchApi - factory interface
 * @export
 */
export const SemanticSearchApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SemanticSearchApiFp(configuration)
    return {
        /**
         * 
         * @summary Search with SemanticSearch;
         * @param {string} [query] Elasticsearch query
         * @param {boolean} [user] Specify user or only public metadata records could be found
         * @param {boolean} [adv] Set true for advanced Elasticsearch search syntax
         * @param {Array<string>} [languages] Set the used languages
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        semanticSearchSearch(query?: string, user?: boolean, adv?: boolean, languages?: Array<string>, options?: any): AxiosPromise<Array<SearchResult>> {
            return localVarFp.semanticSearchSearch(query, user, adv, languages, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * SemanticSearchApi - object-oriented interface
 * @export
 * @class SemanticSearchApi
 * @extends {BaseAPI}
 */
export class SemanticSearchApi extends BaseAPI {
    /**
     * 
     * @summary Search with SemanticSearch;
     * @param {string} [query] Elasticsearch query
     * @param {boolean} [user] Specify user or only public metadata records could be found
     * @param {boolean} [adv] Set true for advanced Elasticsearch search syntax
     * @param {Array<string>} [languages] Set the used languages
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SemanticSearchApi
     */
    public semanticSearchSearch(query?: string, user?: boolean, adv?: boolean, languages?: Array<string>, options?: any) {
        return SemanticSearchApiFp(this.configuration).semanticSearchSearch(query, user, adv, languages, options).then((request) => request(this.axios, this.basePath));
    }
}


