/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.Token
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * Used to parse the json request for add token.
 * @export
 * @interface AddApiTokenParameter
 */
export interface AddApiTokenParameter {
    /**
     * Gets or sets the name of the token. 
     * @type {string}
     * @memberof AddApiTokenParameter
     */
    name?: string | null;
    /**
     * Gets or sets the expiration of the token. 
     * @type {number}
     * @memberof AddApiTokenParameter
     */
    expiration?: number | null;
}
/**
 * 
 * @export
 * @interface ApiTokenObject
 */
export interface ApiTokenObject {
    /**
     * 
     * @type {string}
     * @memberof ApiTokenObject
     */
    tokenId?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiTokenObject
     */
    name?: string | null;
    /**
     * 
     * @type {string}
     * @memberof ApiTokenObject
     */
    created?: string;
    /**
     * 
     * @type {string}
     * @memberof ApiTokenObject
     */
    expires?: string;
}
/**
 * 
 * @export
 * @interface CreatedApiTokenObject
 */
export interface CreatedApiTokenObject {
    /**
     * 
     * @type {string}
     * @memberof CreatedApiTokenObject
     */
    tokenId?: string;
    /**
     * 
     * @type {string}
     * @memberof CreatedApiTokenObject
     */
    name?: string | null;
    /**
     * 
     * @type {string}
     * @memberof CreatedApiTokenObject
     */
    created?: string;
    /**
     * 
     * @type {string}
     * @memberof CreatedApiTokenObject
     */
    expires?: string;
    /**
     * Gets or sets the jwt token value of the token. 
     * @type {string}
     * @memberof CreatedApiTokenObject
     */
    token?: string | null;
}
/**
 * Retuned upon creation of a new token. Contains the jwt token.
 * @export
 * @interface CreatedApiTokenObjectAllOf
 */
export interface CreatedApiTokenObjectAllOf {
    /**
     * Gets or sets the jwt token value of the token. 
     * @type {string}
     * @memberof CreatedApiTokenObjectAllOf
     */
    token?: string | null;
}
/**
 * Contains the minimum and maximum token validity in days from today.
 * @export
 * @interface TokenValidityObject
 */
export interface TokenValidityObject {
    /**
     * Object holding the specified token minumum and maximum validity in days from today.
     * @type {number}
     * @memberof TokenValidityObject
     */
    minDays?: number;
    /**
     * 
     * @type {number}
     * @memberof TokenValidityObject
     */
    maxDays?: number;
}

/**
 * TokenApi - axios parameter creator
 * @export
 */
export const TokenApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Add a new token for the user.
         * @param {AddApiTokenParameter} addApiTokenParameter Parsed from json
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenAddToken: async (addApiTokenParameter: AddApiTokenParameter, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'addApiTokenParameter' is not null or undefined
            assertParamExists('tokenAddToken', 'addApiTokenParameter', addApiTokenParameter)
            const localVarPath = `/Token`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(addApiTokenParameter, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get the specified token minumum and maximum validity in days.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenGetTokenValidityBounds: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Token/getValidity`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get the specific token values.
         * @param {string} tokenId User tokenId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenGetUserToken: async (tokenId: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'tokenId' is not null or undefined
            assertParamExists('tokenGetUserToken', 'tokenId', tokenId)
            const localVarPath = `/Token/{tokenId}`
                .replace(`{${"tokenId"}}`, encodeURIComponent(String(tokenId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List all tokens of the current user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenGetUserTokens: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Token`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revoke a specific token.
         * @param {string} tokenId User tokenId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenRevokeToken: async (tokenId: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'tokenId' is not null or undefined
            assertParamExists('tokenRevokeToken', 'tokenId', tokenId)
            const localVarPath = `/Token/{tokenId}`
                .replace(`{${"tokenId"}}`, encodeURIComponent(String(tokenId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TokenApi - functional programming interface
 * @export
 */
export const TokenApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = TokenApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Add a new token for the user.
         * @param {AddApiTokenParameter} addApiTokenParameter Parsed from json
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tokenAddToken(addApiTokenParameter: AddApiTokenParameter, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CreatedApiTokenObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.tokenAddToken(addApiTokenParameter, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get the specified token minumum and maximum validity in days.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tokenGetTokenValidityBounds(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TokenValidityObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.tokenGetTokenValidityBounds(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get the specific token values.
         * @param {string} tokenId User tokenId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tokenGetUserToken(tokenId: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ApiTokenObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.tokenGetUserToken(tokenId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List all tokens of the current user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tokenGetUserTokens(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<ApiTokenObject>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.tokenGetUserTokens(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revoke a specific token.
         * @param {string} tokenId User tokenId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tokenRevokeToken(tokenId: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<any>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.tokenRevokeToken(tokenId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * TokenApi - factory interface
 * @export
 */
export const TokenApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = TokenApiFp(configuration)
    return {
        /**
         * 
         * @summary Add a new token for the user.
         * @param {AddApiTokenParameter} addApiTokenParameter Parsed from json
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenAddToken(addApiTokenParameter: AddApiTokenParameter, options?: any): AxiosPromise<CreatedApiTokenObject> {
            return localVarFp.tokenAddToken(addApiTokenParameter, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get the specified token minumum and maximum validity in days.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenGetTokenValidityBounds(options?: any): AxiosPromise<TokenValidityObject> {
            return localVarFp.tokenGetTokenValidityBounds(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get the specific token values.
         * @param {string} tokenId User tokenId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenGetUserToken(tokenId: string, options?: any): AxiosPromise<ApiTokenObject> {
            return localVarFp.tokenGetUserToken(tokenId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List all tokens of the current user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenGetUserTokens(options?: any): AxiosPromise<Array<ApiTokenObject>> {
            return localVarFp.tokenGetUserTokens(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revoke a specific token.
         * @param {string} tokenId User tokenId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tokenRevokeToken(tokenId: string, options?: any): AxiosPromise<any> {
            return localVarFp.tokenRevokeToken(tokenId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TokenApi - object-oriented interface
 * @export
 * @class TokenApi
 * @extends {BaseAPI}
 */
export class TokenApi extends BaseAPI {
    /**
     * 
     * @summary Add a new token for the user.
     * @param {AddApiTokenParameter} addApiTokenParameter Parsed from json
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TokenApi
     */
    public tokenAddToken(addApiTokenParameter: AddApiTokenParameter, options?: any) {
        return TokenApiFp(this.configuration).tokenAddToken(addApiTokenParameter, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get the specified token minumum and maximum validity in days.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TokenApi
     */
    public tokenGetTokenValidityBounds(options?: any) {
        return TokenApiFp(this.configuration).tokenGetTokenValidityBounds(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get the specific token values.
     * @param {string} tokenId User tokenId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TokenApi
     */
    public tokenGetUserToken(tokenId: string, options?: any) {
        return TokenApiFp(this.configuration).tokenGetUserToken(tokenId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List all tokens of the current user.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TokenApi
     */
    public tokenGetUserTokens(options?: any) {
        return TokenApiFp(this.configuration).tokenGetUserTokens(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revoke a specific token.
     * @param {string} tokenId User tokenId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TokenApi
     */
    public tokenRevokeToken(tokenId: string, options?: any) {
        return TokenApiFp(this.configuration).tokenRevokeToken(tokenId, options).then((request) => request(this.axios, this.basePath));
    }
}


