/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.User
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.2.1
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import { Configuration } from './configuration';
import globalAxios, { AxiosPromise, AxiosInstance } from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface ContactChangeObject
 */
export interface ContactChangeObject {
    /**
     * 
     * @type {string}
     * @memberof ContactChangeObject
     */
    relationId?: string;
    /**
     * 
     * @type {string}
     * @memberof ContactChangeObject
     */
    userId?: string;
    /**
     * 
     * @type {string}
     * @memberof ContactChangeObject
     */
    newEmail?: string | null;
    /**
     * 
     * @type {string}
     * @memberof ContactChangeObject
     */
    editDate?: string | null;
    /**
     * 
     * @type {string}
     * @memberof ContactChangeObject
     */
    confirmationToken?: string;
}
/**
 * 
 * @export
 * @interface DisciplineObject
 */
export interface DisciplineObject {
    /**
     * 
     * @type {string}
     * @memberof DisciplineObject
     */
    id?: string;
    /**
     * 
     * @type {string}
     * @memberof DisciplineObject
     */
    url?: string | null;
    /**
     * 
     * @type {string}
     * @memberof DisciplineObject
     */
    displayNameDe?: string | null;
    /**
     * 
     * @type {string}
     * @memberof DisciplineObject
     */
    displayNameEn?: string | null;
}
/**
 * 
 * @export
 * @interface ExternalAuthenticatorsObject
 */
export interface ExternalAuthenticatorsObject {
    /**
     * 
     * @type {string}
     * @memberof ExternalAuthenticatorsObject
     */
    id?: string;
    /**
     * 
     * @type {string}
     * @memberof ExternalAuthenticatorsObject
     */
    displayName?: string | null;
}
/**
 * 
 * @export
 * @interface LanguageObject
 */
export interface LanguageObject {
    /**
     * 
     * @type {string}
     * @memberof LanguageObject
     */
    id?: string;
    /**
     * 
     * @type {string}
     * @memberof LanguageObject
     */
    displayName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof LanguageObject
     */
    abbreviation?: string | null;
}
/**
 * 
 * @export
 * @interface TitleObject
 */
export interface TitleObject {
    /**
     * 
     * @type {string}
     * @memberof TitleObject
     */
    id?: string;
    /**
     * 
     * @type {string}
     * @memberof TitleObject
     */
    displayName?: string | null;
}
/**
 * Class representing the TOS version
 * @export
 * @interface Tos
 */
export interface Tos {
    /**
     * The TOS version
     * @type {string}
     * @memberof Tos
     */
    version?: string | null;
}
/**
 * 
 * @export
 * @interface UserObject
 */
export interface UserObject {
    /**
     * 
     * @type {string}
     * @memberof UserObject
     */
    id?: string;
    /**
     * 
     * @type {string}
     * @memberof UserObject
     */
    displayName?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UserObject
     */
    givenname?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UserObject
     */
    surname?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UserObject
     */
    emailAddress?: string | null;
    /**
     * 
     * @type {boolean}
     * @memberof UserObject
     */
    hasProjectRole?: boolean;
    /**
     * 
     * @type {TitleObject}
     * @memberof UserObject
     */
    title?: TitleObject | null;
    /**
     * 
     * @type {LanguageObject}
     * @memberof UserObject
     */
    language?: LanguageObject | null;
    /**
     * 
     * @type {string}
     * @memberof UserObject
     */
    organization?: string | null;
    /**
     * 
     * @type {string}
     * @memberof UserObject
     */
    institute?: string | null;
    /**
     * 
     * @type {Array<DisciplineObject>}
     * @memberof UserObject
     */
    disciplines?: Array<DisciplineObject> | null;
    /**
     * 
     * @type {boolean}
     * @memberof UserObject
     */
    isRegistered?: boolean;
    /**
     * 
     * @type {Array<ExternalAuthenticatorsObject>}
     * @memberof UserObject
     */
    externalAuthenticators?: Array<ExternalAuthenticatorsObject> | null;
}

/**
 * ContactChangeApi - axios parameter creator
 * @export
 */
export const ContactChangeApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary This method enables the user to request a change of his or her contact email. After entering a valid email, a confirmation email will be sent to the new address and a notification email will be sent to the present address.
         * @param {string} body A new email as string set by the user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        contactChangeChangeContactEmail: async (body: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'body' is not null or undefined
            assertParamExists('contactChangeChangeContactEmail', 'body', body)
            const localVarPath = `/ContactChange/emailchange`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(body, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Calling this method checks whether or not the entered confirmation token (verification) exists inside the database for the current user. If yes, it updates the EmailAddress field for that user with the New Email that has been requested with the ChangeContactEmail method.
         * @param {string} verification The Confirmation Token as String for a New Email.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        contactChangeConfirmContactEmail: async (verification: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'verification' is not null or undefined
            assertParamExists('contactChangeConfirmContactEmail', 'verification', verification)
            const localVarPath = `/ContactChange/confirm/{verification}`
                .replace(`{${"verification"}}`, encodeURIComponent(String(verification)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Calling this method will check if there are pending emails for confirmation for the current user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        contactChangeConfirmationStatus: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/ContactChange/status`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ContactChangeApi - functional programming interface
 * @export
 */
export const ContactChangeApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ContactChangeApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary This method enables the user to request a change of his or her contact email. After entering a valid email, a confirmation email will be sent to the new address and a notification email will be sent to the present address.
         * @param {string} body A new email as string set by the user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async contactChangeChangeContactEmail(body: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContactChangeObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.contactChangeChangeContactEmail(body, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Calling this method checks whether or not the entered confirmation token (verification) exists inside the database for the current user. If yes, it updates the EmailAddress field for that user with the New Email that has been requested with the ChangeContactEmail method.
         * @param {string} verification The Confirmation Token as String for a New Email.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async contactChangeConfirmContactEmail(verification: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.contactChangeConfirmContactEmail(verification, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Calling this method will check if there are pending emails for confirmation for the current user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async contactChangeConfirmationStatus(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<ContactChangeObject>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.contactChangeConfirmationStatus(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ContactChangeApi - factory interface
 * @export
 */
export const ContactChangeApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ContactChangeApiFp(configuration)
    return {
        /**
         * 
         * @summary This method enables the user to request a change of his or her contact email. After entering a valid email, a confirmation email will be sent to the new address and a notification email will be sent to the present address.
         * @param {string} body A new email as string set by the user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        contactChangeChangeContactEmail(body: string, options?: any): AxiosPromise<ContactChangeObject> {
            return localVarFp.contactChangeChangeContactEmail(body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Calling this method checks whether or not the entered confirmation token (verification) exists inside the database for the current user. If yes, it updates the EmailAddress field for that user with the New Email that has been requested with the ChangeContactEmail method.
         * @param {string} verification The Confirmation Token as String for a New Email.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        contactChangeConfirmContactEmail(verification: string, options?: any): AxiosPromise<UserObject> {
            return localVarFp.contactChangeConfirmContactEmail(verification, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Calling this method will check if there are pending emails for confirmation for the current user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        contactChangeConfirmationStatus(options?: any): AxiosPromise<Array<ContactChangeObject>> {
            return localVarFp.contactChangeConfirmationStatus(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * ContactChangeApi - object-oriented interface
 * @export
 * @class ContactChangeApi
 * @extends {BaseAPI}
 */
export class ContactChangeApi extends BaseAPI {
    /**
     * 
     * @summary This method enables the user to request a change of his or her contact email. After entering a valid email, a confirmation email will be sent to the new address and a notification email will be sent to the present address.
     * @param {string} body A new email as string set by the user.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContactChangeApi
     */
    public contactChangeChangeContactEmail(body: string, options?: any) {
        return ContactChangeApiFp(this.configuration).contactChangeChangeContactEmail(body, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Calling this method checks whether or not the entered confirmation token (verification) exists inside the database for the current user. If yes, it updates the EmailAddress field for that user with the New Email that has been requested with the ChangeContactEmail method.
     * @param {string} verification The Confirmation Token as String for a New Email.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContactChangeApi
     */
    public contactChangeConfirmContactEmail(verification: string, options?: any) {
        return ContactChangeApiFp(this.configuration).contactChangeConfirmContactEmail(verification, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Calling this method will check if there are pending emails for confirmation for the current user.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContactChangeApi
     */
    public contactChangeConfirmationStatus(options?: any) {
        return ContactChangeApiFp(this.configuration).contactChangeConfirmationStatus(options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * LanguageApi - axios parameter creator
 * @export
 */
export const LanguageApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Returns all available languages.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        languageIndex: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Language`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * LanguageApi - functional programming interface
 * @export
 */
export const LanguageApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = LanguageApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Returns all available languages.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async languageIndex(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<LanguageObject>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.languageIndex(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * LanguageApi - factory interface
 * @export
 */
export const LanguageApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = LanguageApiFp(configuration)
    return {
        /**
         * 
         * @summary Returns all available languages.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        languageIndex(options?: any): AxiosPromise<Array<LanguageObject>> {
            return localVarFp.languageIndex(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * LanguageApi - object-oriented interface
 * @export
 * @class LanguageApi
 * @extends {BaseAPI}
 */
export class LanguageApi extends BaseAPI {
    /**
     * 
     * @summary Returns all available languages.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguageApi
     */
    public languageIndex(options?: any) {
        return LanguageApiFp(this.configuration).languageIndex(options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * TOSApi - axios parameter creator
 * @export
 */
export const TOSApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Calling this method accepts the TOS for the current user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tOSAcceptCurrentTOSVersion: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/TOS`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Returns the current TOS Version.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tOSGetCurrentTOSVersion: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/TOS`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TOSApi - functional programming interface
 * @export
 */
export const TOSApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = TOSApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Calling this method accepts the TOS for the current user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tOSAcceptCurrentTOSVersion(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<number>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.tOSAcceptCurrentTOSVersion(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Returns the current TOS Version.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async tOSGetCurrentTOSVersion(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Tos>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.tOSGetCurrentTOSVersion(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * TOSApi - factory interface
 * @export
 */
export const TOSApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = TOSApiFp(configuration)
    return {
        /**
         * 
         * @summary Calling this method accepts the TOS for the current user.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tOSAcceptCurrentTOSVersion(options?: any): AxiosPromise<number> {
            return localVarFp.tOSAcceptCurrentTOSVersion(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Returns the current TOS Version.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        tOSGetCurrentTOSVersion(options?: any): AxiosPromise<Tos> {
            return localVarFp.tOSGetCurrentTOSVersion(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TOSApi - object-oriented interface
 * @export
 * @class TOSApi
 * @extends {BaseAPI}
 */
export class TOSApi extends BaseAPI {
    /**
     * 
     * @summary Calling this method accepts the TOS for the current user.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TOSApi
     */
    public tOSAcceptCurrentTOSVersion(options?: any) {
        return TOSApiFp(this.configuration).tOSAcceptCurrentTOSVersion(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Returns the current TOS Version.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TOSApi
     */
    public tOSGetCurrentTOSVersion(options?: any) {
        return TOSApiFp(this.configuration).tOSGetCurrentTOSVersion(options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * TitleApi - axios parameter creator
 * @export
 */
export const TitleApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Returns all available titles.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        titleIndex: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/Title`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TitleApi - functional programming interface
 * @export
 */
export const TitleApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = TitleApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Returns all available titles.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async titleIndex(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<TitleObject>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.titleIndex(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * TitleApi - factory interface
 * @export
 */
export const TitleApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = TitleApiFp(configuration)
    return {
        /**
         * 
         * @summary Returns all available titles.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        titleIndex(options?: any): AxiosPromise<Array<TitleObject>> {
            return localVarFp.titleIndex(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TitleApi - object-oriented interface
 * @export
 * @class TitleApi
 * @extends {BaseAPI}
 */
export class TitleApi extends BaseAPI {
    /**
     * 
     * @summary Returns all available titles.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TitleApi
     */
    public titleIndex(options?: any) {
        return TitleApiFp(this.configuration).titleIndex(options).then((request) => request(this.axios, this.basePath));
    }
}


/**
 * UserApi - axios parameter creator
 * @export
 */
export const UserApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Retrieves the UserObject.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userGetUser: async (options: any = {}): Promise<RequestArgs> => {
            const localVarPath = `/User/user`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary This method lets someone query the user database using a query string.
         * @param {string} queryString Search String
         * @param {string} projectId Project from which the search is triggered
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userQuery: async (queryString: string, projectId: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'queryString' is not null or undefined
            assertParamExists('userQuery', 'queryString', queryString)
            // verify required parameter 'projectId' is not null or undefined
            assertParamExists('userQuery', 'projectId', projectId)
            const localVarPath = `/User/query/{queryString}/project/{projectId}`
                .replace(`{${"queryString"}}`, encodeURIComponent(String(queryString)))
                .replace(`{${"projectId"}}`, encodeURIComponent(String(projectId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Sets and returns a merge token.
         * @param {string} provider Specifies the provider from which a user should be merged from
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userSetAndReturnMergeToken: async (provider: string, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'provider' is not null or undefined
            assertParamExists('userSetAndReturnMergeToken', 'provider', provider)
            const localVarPath = `/User/mergeToken/{provider}`
                .replace(`{${"provider"}}`, encodeURIComponent(String(provider)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Updates the User.
         * @param {UserObject} userObject Entry representing the user
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userUpdateUser: async (userObject: UserObject, options: any = {}): Promise<RequestArgs> => {
            // verify required parameter 'userObject' is not null or undefined
            assertParamExists('userUpdateUser', 'userObject', userObject)
            const localVarPath = `/User/user`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter, options.query);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(userObject, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * UserApi - functional programming interface
 * @export
 */
export const UserApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = UserApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Retrieves the UserObject.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userGetUser(options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserObject>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.userGetUser(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary This method lets someone query the user database using a query string.
         * @param {string} queryString Search String
         * @param {string} projectId Project from which the search is triggered
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userQuery(queryString: string, projectId: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<UserObject>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.userQuery(queryString, projectId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Sets and returns a merge token.
         * @param {string} provider Specifies the provider from which a user should be merged from
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userSetAndReturnMergeToken(provider: string, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.userSetAndReturnMergeToken(provider, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Updates the User.
         * @param {UserObject} userObject Entry representing the user
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async userUpdateUser(userObject: UserObject, options?: any): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<number>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.userUpdateUser(userObject, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * UserApi - factory interface
 * @export
 */
export const UserApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = UserApiFp(configuration)
    return {
        /**
         * 
         * @summary Retrieves the UserObject.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userGetUser(options?: any): AxiosPromise<UserObject> {
            return localVarFp.userGetUser(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary This method lets someone query the user database using a query string.
         * @param {string} queryString Search String
         * @param {string} projectId Project from which the search is triggered
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userQuery(queryString: string, projectId: string, options?: any): AxiosPromise<Array<UserObject>> {
            return localVarFp.userQuery(queryString, projectId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Sets and returns a merge token.
         * @param {string} provider Specifies the provider from which a user should be merged from
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userSetAndReturnMergeToken(provider: string, options?: any): AxiosPromise<string> {
            return localVarFp.userSetAndReturnMergeToken(provider, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Updates the User.
         * @param {UserObject} userObject Entry representing the user
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        userUpdateUser(userObject: UserObject, options?: any): AxiosPromise<number> {
            return localVarFp.userUpdateUser(userObject, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * UserApi - object-oriented interface
 * @export
 * @class UserApi
 * @extends {BaseAPI}
 */
export class UserApi extends BaseAPI {
    /**
     * 
     * @summary Retrieves the UserObject.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserApi
     */
    public userGetUser(options?: any) {
        return UserApiFp(this.configuration).userGetUser(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary This method lets someone query the user database using a query string.
     * @param {string} queryString Search String
     * @param {string} projectId Project from which the search is triggered
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserApi
     */
    public userQuery(queryString: string, projectId: string, options?: any) {
        return UserApiFp(this.configuration).userQuery(queryString, projectId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Sets and returns a merge token.
     * @param {string} provider Specifies the provider from which a user should be merged from
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserApi
     */
    public userSetAndReturnMergeToken(provider: string, options?: any) {
        return UserApiFp(this.configuration).userSetAndReturnMergeToken(provider, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Updates the User.
     * @param {UserObject} userObject Entry representing the user
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof UserApi
     */
    public userUpdateUser(userObject: UserObject, options?: any) {
        return UserApiFp(this.configuration).userUpdateUser(userObject, options).then((request) => request(this.axios, this.basePath));
    }
}


